window.Gleam.initSearch([{"doc":"gmysql","title":"gmysql","content":"# gmysql\n\n[![Package Version](https://img.shields.io/hexpm/v/gmysql)](https://hex.pm/packages/gmysql)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/gmysql/)\n\n```sh\ngleam add gmysql\n```\n```gleam\nimport gmysql\nimport gleam/dynamic\n\npub fn main() {\n  let assert Ok(connection) = gmysql.connect([])\n  gmysql.query(\n    connection,\n    &quot;SELECT * FROM users WHERE id = ?;&quot;,\n    [gmysql.to_param(&quot;user_id&quot;)],\n    1000,\n    dynamic.tuple3(dynamic.string, dynamic.string, dynamic.string)\n  )\n}\n```\n\nFurther documentation can be found at &lt;https://hexdocs.pm/gmysql&gt;.\n\n## Development\n\n```sh\ngleam run   # Run the project\ngleam test  # Run the tests\ngleam shell # Run an Erlang shell\n```\n","url":"index.html"},{"doc":"gmysql","title":"Connection","content":"pub type Connection\n\n\nSynonyms:\ngmysql.Connection\ngmysql Connection","url":"gmysql.html#Connection"},{"doc":"gmysql","title":"ConnectionMode","content":"pub type ConnectionMode {\n  Synchronous\n  Asynchronous\n  Lazy\n}\n\nSynchronous\n\n\nAsynchronous\n\n\nLazy\n\n\nSynonyms:\ngmysql.ConnectionMode\ngmysql ConnectionMode","url":"gmysql.html#ConnectionMode"},{"doc":"gmysql","title":"ConnectionOption","content":"pub type ConnectionOption {\n  Host(String)\n  Port(Int)\n  User(String)\n  Password(String)\n  Database(String)\n  ConnectMode(ConnectionMode)\n  ConnectTimeout(Int)\n  KeepAlive(Int)\n}\n\nHost(String)\n\n\nPort(Int)\n\n\nUser(String)\n\n\nPassword(String)\n\n\nDatabase(String)\n\n\nConnectMode(ConnectionMode)\n\n\nConnectTimeout(Int)\n\n\nKeepAlive(Int)\n\n\nSynonyms:\ngmysql.ConnectionOption\ngmysql ConnectionOption","url":"gmysql.html#ConnectionOption"},{"doc":"gmysql","title":"Error","content":"pub type Error {\n  ServerError(Int, BitArray)\n  UnknownError(Dynamic)\n  DecodeError(dynamic.DecodeErrors)\n}\n\nServerError(Int, BitArray)\n\n\nUnknownError(Dynamic)\n\n\nDecodeError(dynamic.DecodeErrors)\n\n\nSynonyms:\ngmysql.Error\ngmysql Error","url":"gmysql.html#Error"},{"doc":"gmysql","title":"Param","content":"pub type Param\n\n\nSynonyms:\ngmysql.Param\ngmysql Param","url":"gmysql.html#Param"},{"doc":"gmysql","title":"TransactionError","content":"pub type TransactionError(a) {\n  FunctionError(a)\n  OtherError(Dynamic)\n}\n\nFunctionError(a)\n\n\nOtherError(Dynamic)\n\n\nSynonyms:\ngmysql.TransactionError\ngmysql TransactionError","url":"gmysql.html#TransactionError"},{"doc":"gmysql","title":"close","content":"pub fn close(connection: Connection) -&gt; Nil\n\nSynonyms:\ngmysql.close\ngmysql close","url":"gmysql.html#close"},{"doc":"gmysql","title":"connect","content":"pub fn connect(\n  options: List(ConnectionOption),\n) -&gt; Result(Connection, Dynamic)\n\nSynonyms:\ngmysql.connect\ngmysql connect","url":"gmysql.html#connect"},{"doc":"gmysql","title":"exec","content":"pub fn exec(\n  connection: Connection,\n  query: String,\n  timeout: Int,\n) -&gt; Result(Nil, Error)\n\nSynonyms:\ngmysql.exec\ngmysql exec","url":"gmysql.html#exec"},{"doc":"gmysql","title":"query","content":"pub fn query(\n  connection: Connection,\n  query: String,\n  params: List(Param),\n  timeout: Int,\n  decoder: fn(Dynamic) -&gt; Result(a, List(DecodeError)),\n) -&gt; Result(a, Error)\n\nSynonyms:\ngmysql.query\ngmysql query","url":"gmysql.html#query"},{"doc":"gmysql","title":"to_param","content":"pub fn to_param(param: a) -&gt; Param\n\nSynonyms:\ngmysql.to_param\ngmysql to_param","url":"gmysql.html#to_param"},{"doc":"gmysql","title":"with_connection","content":"pub fn with_connection(\n  options: List(ConnectionOption),\n  with function: fn(Connection) -&gt; a,\n) -&gt; Result(a, Dynamic)\n\nSynonyms:\ngmysql.with_connection\ngmysql with_connection","url":"gmysql.html#with_connection"},{"doc":"gmysql","title":"with_transaction","content":"pub fn with_transaction(\n  connection: Connection,\n  retry retries: Int,\n  with function: fn(Connection) -&gt; Result(a, b),\n) -&gt; Result(a, TransactionError(b))\n Execute a function within a transaction.\n If the function throws or returns an error, it will rollback.\n You can nest this function, which will create a savepoint.\nSynonyms:\ngmysql.with_transaction\ngmysql with_transaction","url":"gmysql.html#with_transaction"},{"doc":"gmysql","title":"gmysql","content":"","url":"gmysql.html"}]);